class Kugel {

   protected PVector position;
   protected PVector geschwindigkeit;
   protected float radius;
   protected color farbe;

  Kugel(PVector p, float r, PVector v, color f) {
    position = p;
    geschwindigkeit = v;
    radius = r;
    farbe = f;
  }
  
  void setPos(PVector pos) { position = new PVector(pos.x,pos.y); }
  void setGeschw(PVector geschw) { geschwindigkeit = new PVector(geschw.x,geschw.y); }
  PVector getPos() { return position; }
  PVector getGeschw() { return geschwindigkeit; }

  void aktualiseren() { 
    position = position.add(geschwindigkeit);
    geschwindigkeit.x *= friction;
    geschwindigkeit.y *= friction;
  }
  
  void pruefeKollisionRand() {
    if (position.x >= width-radius) {
      position.x = width-radius;
      geschwindigkeit.x *= -1;      
   } else if (position.x <=radius) {
      position.x = radius;
      geschwindigkeit.x *= -1;
    } else if (position.y >= height-radius) {
      position.y = height-radius;
      geschwindigkeit.y *= -1;
    } else if (position.y <= radius) {
      position.y = radius;
      geschwindigkeit.y *= -1;
    }
  }
  
  void pruefeKollisionZylinder() {
       PVector normale = PVector.sub(position,new PVector(hindernis_x,hindernis_y)); 
       if (normale.mag()<= hindernis_rad + radius) {
           normale.normalize();
           PVector tangente = new PVector(-normale.y,normale.x);
           float sp = tangente.dot(geschwindigkeit);
           if (sp<=0) tangente.mult(-1); 
           tangente.normalize();
           float nv = geschwindigkeit.dot(normale);
           float tv = geschwindigkeit.dot(tangente); 
           geschwindigkeit = normale.mult(-nv).add(tangente.mult(tv));
       }
  }

  void display() {  
    stroke(0);
    fill(farbe);
    ellipse(position.x, position.y, radius*2, radius*2); 
  }
}